import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Scanner;

import jpcap.JpcapCaptor;
import jpcap.JpcapSender;
import jpcap.NetworkInterface;
import jpcap.packet.EthernetPacket;
import jpcap.packet.IPPacket;
import jpcap.packet.TCPPacket;

public class Send_packets {

	/**
	 * @param args
	 * @throws Exception
	 * @throws UnknownHostException
	 */
	public static void main(String[] args) throws Exception {

		String fName = "/home/sanja7s/workspace/testdata/access_log.091231";

		printDevices();

		// System.out.println("Opening file and trying to send traffic");
		// try {
		// generateTraffic(fName, 2);
		// } catch (UnknownHostException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		// System.out.println("Traffic sent succesfully.");

		test();

	}

	public static void test() throws Exception {

		// sendPacket("IP","192.168.56.1", 2);
		// sendPacket("name", "b3091057.crawl.yahoo.net", 2);
		ParseIPString("c-66-41-35-239.hsd1.mn.comcast.net");
	}

	public static void printDevices() {

		// Obtain the list of network interfaces
		NetworkInterface[] devices = JpcapCaptor.getDeviceList();

		// for each network interface
		for (int i = 0; i < devices.length; i++) {
			// print out its name and description
			System.out.println(i + ": " + devices[i].name + "("
					+ devices[i].description + ")");

		}

	}

	/** Template method that calls {@link #processLine(String)}. */
	public final static void sendLineByLine(File fFile, int interfaceID)
			throws FileNotFoundException {
		// Note that FileReader is used, not File, since File is not Closeable
		Scanner scanner = new Scanner(new FileReader(fFile));
		try {
			// first use a Scanner to get each line
			while (scanner.hasNextLine()) {
				processLine(scanner.nextLine(), interfaceID);
			}
		} finally {
			// ensure the underlying stream is always closed
			// this only has any effect if the item passed to the Scanner
			// constructor implements Closeable (which it does in this case).
			scanner.close();
		}
	}

	protected static void processLine(String aLine, int interfaceID) {
		// use a second Scanner to parse the content of each line
		Scanner scanner = new Scanner(aLine);
		scanner.useDelimiter(" - - ");
		if (scanner.hasNext()) {
			String IPaddress = scanner.next();
			// String value = scanner.next();
			// log("Name is : " + quote(name.trim()) + ", and Value is : " +
			// quote(value.trim()) );
			System.out.println("Address is: " + IPaddress);

			// sendPacket();
		} else {
			// log("Empty or invalid line. Unable to process.");
			System.out.println("Empty or invalid line. Unable to process.");
		}
		// no need to call scanner.close(), since the source is a String
	}

	public static void generateTraffic(String fName, int interfaceID)
			throws UnknownHostException, FileNotFoundException {
		// TODO Auto-generated method stub

		// printDevices();

		File fFile = new File(fName);
		sendLineByLine(fFile, interfaceID);
	}

	public static void sendPacket(String type, String IPaddress,
			int interfaceIndex) throws Exception {

		// Obtain the list of network interfaces
		NetworkInterface[] devices = JpcapCaptor.getDeviceList();

		// open a network interface to send a packet to
		JpcapSender sender = null;
		try {
			sender = JpcapSender.openDevice(devices[interfaceIndex]);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// create a TCP packet with specified port numbers, flags, and other
		// parameters
		TCPPacket p = new TCPPacket(12, 34, 56, 78, false, false, false, false,
				true, true, true, true, 10, 10);

		if (type == "name") {
			// specify IPv4 header parameters
			p.setIPv4Parameter(0, false, false, false, 0, false, false, false,
					0, 1010101, 100, IPPacket.IPPROTO_TCP, InetAddress
							.getByAddress(new byte[] { (byte) 0, (byte) 1,
									(byte) 2, (byte) 3 }), InetAddress
							.getByName(IPaddress));
		} else if (type == "IP") {
			byte[] srcIP = ParseIPString(IPaddress);
			p.setIPv4Parameter(0, false, false, false, 0, false, false, false,
					0, 1010101, 100, IPPacket.IPPROTO_TCP, InetAddress
							.getByAddress(new byte[] { (byte) 0, (byte) 1,
									(byte) 2, (byte) 3 }), InetAddress
							.getByAddress(srcIP));
		} else {
			System.out.println("Invalid address in this pass. No packet sent.");
			return;
		}

		// set the data field of the packet
		p.data = ("data").getBytes();

		// create an Ethernet packet (frame)
		EthernetPacket ether = new EthernetPacket();
		// set frame type as IP
		ether.frametype = EthernetPacket.ETHERTYPE_IP;
		// set source and destination MAC addresses
		ether.src_mac = new byte[] { (byte) 0, (byte) 1, (byte) 2, (byte) 3,
				(byte) 4, (byte) 5 };
		ether.dst_mac = new byte[] { (byte) 0, (byte) 6, (byte) 7, (byte) 8,
				(byte) 9, (byte) 10 };

		// set the datalink frame of the packet p as ether
		p.datalink = ether;

		// send the packet p
		sender.sendPacket(p);

		sender.close();
	}

	public static byte[] ParseIPString(String IPAddress) {

		byte[] result = new byte[4];

		String delim = "[.]+";
		System.out.println(IPAddress);

		String[] sBytes = IPAddress.split(delim);

		System.out.println(sBytes[0]);

		int[] iByte = new int[4];
		for (int i = 0; i < 4; i++) {
			try {
				iByte[i] = Integer.parseInt(sBytes[i]);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
		}
		for (int i = 0; i < 4; i++) {
			result[i] = (byte) iByte[i];
		}

		return result;
	}
}
