


public class TestIt {

	public static void main(String[] args) {

		// int N = 5;
		//
		// Fraction alpha[] = { new Fraction(1, 16), new Fraction(1, 7),
		// new Fraction(2, 18), new Fraction(3, 7), new Fraction(1, 11) };
		// Fraction beta[] = { new Fraction(1, 9), new Fraction(1, 10),
		// new Fraction(3, 1), new Fraction(2, 7), new Fraction(3, 2) };
		// Fraction roUser[] = { new Fraction(1, 10), new Fraction(1, 10),
		// new Fraction(3, 10), new Fraction(2, 10), new Fraction(3, 10) };
		// Fraction roOptimum[] = new Fraction[N];
		// Fraction roConcreteOptimum[] = new Fraction[N];
		// Fraction betaOptimum[] = new Fraction[N];
		// Fraction betaOptimum2[] = new Fraction[N];

		int N = 3;

		Fraction alpha[] = { new Fraction(1, 2), new Fraction(1, 17),
				new Fraction(1, 10) };
		Fraction beta[] = { new Fraction(1, 2), new Fraction(4, 1),
				new Fraction(1, 7) };
		Fraction roUser[] = { new Fraction(1, 10), new Fraction(5, 10),
				new Fraction(2, 5) };
		Fraction roOptimum[] = new Fraction[N];
		Fraction roAdaptedOptimum[] = new Fraction[N];
		Fraction betaOptimum[] = new Fraction[N];
		Fraction betaOptimum2[] = new Fraction[N];

		// calculate variables
		Fraction sumA = Formulae.sumOfCapacity(alpha);
		Fraction sumB = Formulae.sumOfCapacity(beta);
		Fraction sumRoUser = Formulae.sumOfCapacity(roUser);
		
		roOptimum = Formulae.optimumReservations(alpha);
		
		// check data

		for (int i = 0; i < N; i++) {
			if (alpha[i].plus(beta[i]).compareTo(roOptimum[i]) <= 0) {
				System.out.printf("No attack at the cluster %d", i + 1);
				System.out.println();
				System.exit(0);
			}
		}

		if (sumA.compareTo(1) > 0) {
			System.out.println("Honest traffic exceeds 1");
			System.exit(0);
		}

		if (sumRoUser.compareTo(1) != 0) {
			System.out.println("Wrong user reservations, sum not equal 1");
			System.exit(0);
		}

		// Proba resenja bez prelivanja - tj beta_i su preko 1 stop s ideojm
		if (sumA.plus(sumB).compareTo(1) <= 0) {
			System.out
					.println("No attack, honest plus attackers traffic do not exceed 1");
		}

		// formulae
		System.out.println("Honest traffic");
		Formulae.printReservations(alpha);

		System.out.println("Attackers traffic");
		Formulae.printReservations(beta);
		
		System.out.println("User reservations");
		Formulae.printReservations(roUser);

		System.out.println("Optimum reservations");
		Formulae.printReservations(roOptimum);

		roAdaptedOptimum = Formulae.optimumAdaptiveReservations(alpha, beta);
		System.out.println("Adapted optimum reservations");
		Formulae.printReservations(roAdaptedOptimum);

		betaOptimum2 = Formulae.optimumAttackersStrategy2(alpha, beta, roUser);
		System.out.println("Attackers OPTIMUM strategy to the USER strategy");
		Formulae.printReservations(betaOptimum2);
		
		betaOptimum = Formulae.optimumAttackersStrategy1(alpha, beta);
		System.out
				.println("Attackers OPTIMUM strategy to the OPTIMUM strategy");
		betaOptimum = Formulae
				.optimumAttackersStrategy2(alpha, beta, roOptimum);
		Formulae.printReservations(betaOptimum);




		// RESULTS of different strategies to the given attackers - defender adapts
		System.out.println();
		System.out.println("User adaptations");

		System.out.println();
		System.out.println("Result of USER strategy: ");
		Formulae.defaultFormula(alpha, beta, roUser);

		System.out.println();
		System.out.println("Result of OPTIMUM strategy: ");
		Formulae.defaultFormula(alpha, beta, roOptimum);
		
		System.out.println();
		System.out.println("Result of ADAPTED OPTIMUM strategy: ");
		Formulae.defaultFormula(alpha, beta, roAdaptedOptimum);

		Formulae.FormulaNoClusters(alpha, beta);
		
		// Results of different strategies of the attacker - attacker si adapting
		System.out.println();
		System.out.println("Attacker adaptations");
		System.out.println();
		
		System.out
				.println("Result of attackers OPTIMUM strategy on USER strategy: ");
		Formulae.defaultFormula(alpha, betaOptimum2, roUser);

//		System.out
//				.println("Result of attackers OPTIMUM strategy  adapted to OPTIMUM strategy on USER strategy: ");
//		Formulae.defaultFormula(alpha, betaOptimum, roUser);

		// betaOptimum = Formulae
		// .optimumAttackersStrategy2(alpha, beta, roOptimum);
		// System.out
		// .println("Attackers OPTIMUM traffic adapted to OPTIMUM strategy");
		// Formulae.printReservations(betaOptimum);
		System.out.println();
		System.out
				.println("Result of attackers OPTIMUM strategy on OPTIMUM strategy: ");
		Formulae.defaultFormula(alpha, betaOptimum, roOptimum);
		
		
		System.out.println();
		System.out
				.println("Result of attackers EVEN strategy on USER strategy: ");
		Formulae.defaultFormula(alpha, Formulae.evenAttackersTraffic(roUser, Formulae.sumOfCapacity(beta)), roUser);
		
		System.out.println();
		System.out
				.println("Result of attackers EVEN strategy on OPTIMUM strategy: ");
		Formulae.defaultFormula(alpha, Formulae.evenAttackersTraffic(roOptimum, Formulae.sumOfCapacity(beta)), roOptimum);

	}

}
