#
# File containing various test/test run functions
#

from BitTree import BitNodeStruct
from copy import deepcopy
import Algorithms
import AttackModels
import BitTree
import Builders
import EvaluationFunctions
import IPGenerator
import Loaders
import Logger
import Structures
#from BitTree import BitTreeNode

def test():
	
	Logger.initLogger()
	print("Running some tests")
	#testCIDRs()
	#testIPGeneration()
	#testBitTreeInsertSearch()
	#testBitTreeOutput()
	#testBitStuff()
	#testMultiChildWrapperAndTree()
	testEntropy()
	
	
def testEntropy():
	#initializations
	datastructure = Structures.IPLists("datastructure7s")
	treelist7s = Structures.TreeLists()
	
	#if Loaders.loadApacheLog('/home/sanja7s/workspace/ClusterTester7smain/testdata/access_log.091231',datastructure):
	if Loaders.loadApacheLog('/home/sanja7s/workspace/ClusterTester7smain/testdata/entropy_test',datastructure):
		Builders.buildIPTree(datastructure, treelist7s, 'testEntropyTree')
		tree = treelist7s.getTree('testEntropyTree')
		
		print('Testing entropy of the root node, i.e., whole dataset entropy ')
		
		leafsFreq = EvaluationFunctions.getLeafFrequenciesOfNode(tree.root)
		#print(leafsFreq) 
		#for item in leafsFreq.items():
		#	print(item)
		totalEntropy = EvaluationFunctions.calculateEntropy(leafsFreq)
		print("Total dataset entropy ",totalEntropy)
		print()
		print('Testing entropy of a clustering')
		
		clustering = Algorithms.HHHinspiredPerPercentage(tree.root, tree.root, 30)
		#for cluster in clustering:
			#leafFrequencies = EvaluationFunctions.getLeafFrequenciesOfCluster(cluster,cluster,clustering)
			#Entropy = EvaluationFunctions.calculateEntropy(leafFrequencies)
		clusteringEntropy = EvaluationFunctions.getClusteringAvgSumEntropy(clustering,tree)
		print("Total clustering entropy ",clusteringEntropy)	
		#clusteringEntropy = EvaluationFunctions.getClusteringEntropy(clustering)
		#print("Clustering entropy  ", clusteringEntropy)
		min = 1
		max = 25
		step = 1
		#EvaluationFunctions.printClusteringAvgEntropiesPerThreshold(clustering, tree, min, max, step)
		
		"""print('Testing entropies of different threshold clusterings')
		for i in [7]:
			print('Testing entropy of the clustering with threshold  ',i,' pct')
		
			clustering = Algorithms.HHHinspiredPerPercentage(rootNode, rootNode, i)	
			clusteringEntropy = EvaluationFunctions.getClusteringEntropy(clustering)
			print("Clustering entropy  ", clusteringEntropy)"""
			
			
	
def testCIDRs():
	print("Testing CIDR creation and validation")
	print("Valid CIDRs:")
	IPGenerator.CIDR("64.0.0.0/2")
	IPGenerator.CIDR("0.0.0.0/0")
	IPGenerator.CIDR("255.254.0.0/15")
	IPGenerator.CIDR("255.255.255.255/32")
	
	print("Invalid CIDRs:")
	IPGenerator.CIDR("0.0.1.0/16")
	IPGenerator.CIDR("1.0.0.0/1")
	IPGenerator.CIDR("255.253.0.0/15")
	IPGenerator.CIDR("255.255.255.255/33")
	
def testIPGeneration():
	print("Testing IP creation through CIDR and printout")
	cidr = IPGenerator.CIDR("255.254.0.0/15")
	print("IPs:")
	print(IPGenerator.getIPStringFromIPNum(int(cidr.generateIP())))
	print(IPGenerator.getIPStringFromIPNum(int(cidr.generateIP())))
	print(IPGenerator.getIPStringFromIPNum(int(cidr.generateIP())))

def testBitTreeInsertSearch():
	btree = BitTree.BitTree("Test1")
	btree.insert(0xFFFF0000, "good")
	btree.insert(0xFFFF0000, "neutral")
	btree.insert(0xFFFF0001, "evil")
	btree.insert(0xFFFF1000)
	print("Expecting count:2, returned count:" + str(btree.search(0xFFFF0000)))
	print("Expecting count:2, returned count:" + str(btree.search(0xFFFF0000, 32)))
	print("Expecting count:1, returned count:" + str(btree.search(0xFFFF0001, 32)))
	print("Expecting count:3, returned count:" + str(btree.search(0xFFFF0001, 31)))
	print("Expecting count:3, returned count:" + str(btree.search(0xFFFF0000, 28)))
	print("Expecting count:1, returned count:" + str(btree.search(0xFFFF1000, 32)))
	print("Expecting count:4, returned count:" + str(btree.search(0x12345678, 0)))
	print("Expecting count:0, returned count:" + str(btree.search(0x12345678, 16)))
	
def testBitTreeOutput():
	btree = BitTree.BitTree("Test2")
	btree.insert(0x00000000)
	btree.insert(0xFFFF0000)
	btree.insert(0x0000FFFF)
	btree.insert(0xFFFFFFFF)
	btree.insert(0xFFFFFFFD)
	btree.insert(0xFFFFFFFC)
	#print(IPGenerator.getIPStringFromIPNum(0xFFFFFFFC))
	btree.output("dot", "./testoutput.dot")
	print("BitTree output test done")
	

"""def testBitStuff():
	node1 = BitTreeNode()
	node2 = BitTreeNode()
	node3 = BitTreeNode()
	node4 = BitTreeNode()
	node5 = BitTreeNode()
	node6 = BitTreeNode()
	
	node1.idNum = 0x00000000
	node1.rootDist = 0
	node2.idNum = 0x07FFFFFF
	node2.rootDist = 5
	
	print("Expecting matches 5, received matches: " + str(node2.getSubNodeMatch(node1)))
	print("Expecting matches -1, received matches: " + str(node1.getSubNodeMatch(node2)))
	
	node3.idNum = 0xAAAA5555
	node3.rootDist = 32
	node4.idNum = 0xAAAA5555
	node4.rootDist = 32
	
	print("Expecting matches 32, received matches: " + str(node3.getSubNodeMatch(node4)))
	print("Expecting matches 32, received matches: " + str(node4.getSubNodeMatch(node3)))
	
	node5.idNum = 0xFFFFFFFF
	node5.rootDist = 3
	node6.idNum = 0xFFFFFFFF
	node6.rootDist = 5
	
	print("Expecting matches 5, received matches: " + str(node6.getSubNodeMatch(node5)))
	print("Expecting matches -1, received matches: " + str(node5.getSubNodeMatch(node6)))
"""	
	
def testMultiChildWrapperAndTree():
	node1 = deepcopy(BitNodeStruct)
	node2 = deepcopy(BitNodeStruct)
	node3 = deepcopy(BitNodeStruct)
	node4 = deepcopy(BitNodeStruct)
	node5 = deepcopy(BitNodeStruct)
	node6 = deepcopy(BitNodeStruct)

	wrapTree = BitTree.MultiChildWrapperTree()
	
	node1['idNum'] = 0x00000000
	node1['rootDist'] = 0
	
	node6['idNum'] = 0x40000000
	node6['rootDist'] = 2
	
	node4['idNum'] = 0x00010000
	node4['rootDist'] = 16
	
	node2['idNum'] = 0x00010000
	node2['rootDist'] = 32
	
	node3['idNum'] = 0x40000101
	node3['rootDist'] = 32
	
	node5['idNum'] = 0x00000100
	node5['rootDist'] = 32
	
	#print("Expecting matches 8, received matches: " + str(node2.getSubNodeMatch(node1)))
	#print("Expecting matches 8, received matches: " + str(node3.getSubNodeMatch(node1)))
	#print("Expecting matches 8, received matches: " + str(node3.getSubNodeMatch(node2)))

	#note: must insert root first in level order
	wrapTree.insert(node1)
	wrapTree.insert(node6)
	wrapTree.insert(node4)
	wrapTree.insert(node4)
	wrapTree.insert(node2)
	wrapTree.insert(node3)
	wrapTree.insert(node5)
	
	
	wrapTree.output("dot", "./testMultiChildWrapperAndTree.dot")
	
	#finally create the analyser module and relocate all analysis functionality there
	#also link the UI to multichildtree printouts ;)

if __name__ == '__main__':
	test()