'''
Created on Mar 17, 2011

@author: sanja7s
'''
import math

def getLeafFrequencies(node, attribute='idNum'):
    
    leafFrequencies = {}
    
    if node['left'] != None:
        leftSubtreeFrequencies = getLeafFrequencies(node['left'])
        for k in leftSubtreeFrequencies:
            if k in leafFrequencies:
                leafFrequencies[k] = leafFrequencies[k] + leftSubtreeFrequencies[k]
            else:
                leafFrequencies[k] = leftSubtreeFrequencies[k]
    if node['right'] != None:
        rightSubtreeFrequencies = getLeafFrequencies(node['right'])
        for k in rightSubtreeFrequencies:
            if k in leafFrequencies:
                leafFrequencies[k] = leafFrequencies[k] + rightSubtreeFrequencies[k]
            else:
                leafFrequencies[k] = rightSubtreeFrequencies[k]
               
    if node['left'] == None and node['right'] == None:
        leafTotalCount = node['countGood'] + node['countNeutral'] + node['countEvil']
        if node[attribute] in leafFrequencies:
            leafFrequencies[node[attribute]] += leafTotalCount
        else:
            leafFrequencies[node[attribute]] = leafTotalCount
       
    return leafFrequencies
    

def calculateEntropy(dataItemFrequencies):
    """
    Calculates the entropy of the given data set and its items' frequencies.
    """
    dataEntropy = 0.0
    totalCount = 0
    
    for itemCount in dataItemFrequencies.values():
        totalCount += itemCount
    print(totalCount)

    #Calculate the entropy of the data for the target attribute
    for itemCount in dataItemFrequencies.values():
        dataEntropy += (-itemCount/totalCount) * math.log(itemCount/totalCount, 2) 
        
    return dataEntropy